# Class default

Legend for external layers

#### Hierarchy

- GmfDatasourceOGC
  - default

- Defined in src/datasource/ExternalOGC.js:33

#####
Index

### Constructors

constructor

### Properties

attributes
dimensionsConfig
dimensionsFiltersConfig
filterCondition_
filterRules
filtrable
inRange
timeLowerValue
timeUpperValue
visible
wfsUrl_

### Accessors

activeDimensions
combinableForWFS
combinableForWMS
copyable
dimensions
filterCondition
gmfLayer
id
identifierAttribute
legend
maxResolution
minResolution
name
ogcAttributesWFS
ogcAttributesWMS
ogcImageType
ogcServerType
ogcType
queryIconPosition
queryable
snappable
snappingToEdges
snappingToVertice
snappingTolerance
supportsAttributes
supportsDynamicInRange
supportsWFS
supportsWMS
supportsWMTS
timeAttributeName
timeProperty
timeRangeValue
wfsFeatureNS
wfsFeaturePrefix
wfsFormat
wfsLayers
wfsOutputFormat
wfsUrl
wmsFormat
wmsInfoFormat
wmsIsSingleTile
wmsLayers
wmsUrl
wmtsLayer
wmtsUrl

### Methods

combinableWithDataSourceForWFS
combinableWithDataSourceForWMS
geometryName
getAttributes
getCommonOGCAttributes_
getFiltrableWFSLayerName
getInRangeWFSLayerNames
getWFSLayerNames
getWMSLayerNames
haveTheSameActiveDimensions
haveTheSameActiveDimensionsFilters
isAnyOGCLayerInRange
setAttributes

##
Constructors

### constructor

- new default(options, legend): default

- A `gmf.externalDatasource.OGC` extends a `gmf.datasource.OGC` and adds some properties that are proper to GMF and external dataSource only.

  #### Parameters

  - options: OGCOptions

    Options.

  - legend: Legend

    The legend object.

  #### Returns default

  Overrides gmfDatasourceOGC.constructor

  - Defined in src/datasource/ExternalOGC.js:41

##
Properties

### attributes

attributes: Attribute[]

The attributes of the data source.

Note: `attributes` is not using the conventionnal getter/setter due to: See: https://github.com/google/closure-compiler/issues/1089

Inherited from gmfDatasourceOGC.attributes

- Defined in src/datasource/DataSource.js:105
- Defined in src/datasource/DataSource.js:165

### dimensionsConfig

dimensionsConfig: {}

The dimensions configuration for the data source.

Inherited from gmfDatasourceOGC.dimensionsConfig

- Defined in src/datasource/OGC.js:258

### dimensionsFiltersConfig

dimensionsFiltersConfig: {}

The dimensions applied by filters configuration for the data source.

Inherited from gmfDatasourceOGC.dimensionsFiltersConfig

- Defined in src/datasource/OGC.js:265

### filterCondition_

filterCondition_: string

The filter condition to apply to the filter rules (if any).

Inherited from gmfDatasourceOGC.filterCondition_

- Defined in src/datasource/OGC.js:272
- Defined in src/datasource/OGC.js:629

### filterRules

filterRules: Rule[]

A list of filter rules to apply to this data source using the filter condition.

Inherited from gmfDatasourceOGC.filterRules

- Defined in src/datasource/OGC.js:280

### filtrable

filtrable: boolean

Whether the data source is filtrable or not. When `null`, that means that we do not know if the data source if filtrable or not, yet. In that case, the value of the property needs to be determined from an external way.

Inherited from gmfDatasourceOGC.filtrable

- Defined in src/datasource/OGC.js:290

### inRange

inRange: boolean

A data source is considered 'in range' when it is synchronized to a map view and the resolution of that view is within the range of the `maxResolution` and `minResolution`. These 2 properties are required for the `inRange` property to be dynamic, otherwise its value is always `true` by default.

The synchronization is made in the `import('ngeo/datasource/DataSource').DataSources` service.

Inherited from gmfDatasourceOGC.inRange

- Defined in src/datasource/DataSource.js:85

### timeLowerValue

timeLowerValue: number

Time lower value.

Inherited from gmfDatasourceOGC.timeLowerValue

- Defined in src/datasource/OGC.js:431
- Defined in src/datasource/OGC.js:657
- Defined in src/datasource/OGC.js:660

### timeUpperValue

timeUpperValue: number

Time upper value.

Inherited from gmfDatasourceOGC.timeUpperValue

- Defined in src/datasource/OGC.js:444
- Defined in src/datasource/OGC.js:656
- Defined in src/datasource/OGC.js:659

### visible

visible: boolean

Whether the data source is visible or not, i.e. whether its is ON or OFF. Defaults to `false`.

Inherited from gmfDatasourceOGC.visible

- Defined in src/datasource/DataSource.js:93

### wfsUrl_

wfsUrl_: string

The url to use for (WFS) requests.

Inherited from gmfDatasourceOGC.wfsUrl_

- Defined in src/datasource/OGC.js:475

##
Accessors

### activeDimensions

- get activeDimensions(): {}

- #### Returns {}

  Active dimensions

  Inherited from gmfDatasourceOGC.activeDimensions

  - Defined in src/datasource/OGC.js:868

### combinableForWFS

- get combinableForWFS(): boolean

- A data source can't be combined to other data source to issue a single WFS request if:

  - it has filter rules set
  - it has time range set

  #### Returns boolean

  Whether the data source can be combined to an other data source to fetch features in a single WFS request.

  Inherited from gmfDatasourceOGC.combinableForWFS

  - Defined in src/datasource/OGC.js:899

### combinableForWMS

- get combinableForWMS(): boolean

- A data source can't be combined to other data source to issue a single WMS request if:

  - it has filter rules set
  - it has time range set

  #### Returns boolean

  Whether the data source can be combined to an other data source to fetch features in a single WMS request.

  Inherited from gmfDatasourceOGC.combinableForWMS

  - Defined in src/datasource/OGC.js:913

### copyable

- get copyable(): boolean

- #### Returns boolean

  Copyable

  Inherited from gmfDatasourceOGC.copyable

  - Defined in src/datasource/OGC.js:679

### dimensions

- get dimensions(): {}

- #### Returns {}

  Current dimensions to use for this data source

  Inherited from gmfDatasourceOGC.dimensions

  - Defined in src/datasource/OGC.js:614

### filterCondition

- get filterCondition(): string

- #### Returns string

  Filter condition

  Inherited from gmfDatasourceOGC.filterCondition

  - Defined in src/datasource/OGC.js:621
- set filterCondition(filterCondition): void

- #### Parameters

  - filterCondition: string

    Filter condition

  #### Returns void

  Inherited from gmfDatasourceOGC.filterCondition

  - Defined in src/datasource/OGC.js:628

### gmfLayer

- get gmfLayer(): GmfLayer

- #### Returns GmfLayer

  GMF layer

  Inherited from gmfDatasourceOGC.gmfLayer

  - Defined in src/datasource/OGC.js:857

### id

- get id(): number

- #### Returns number

  Id

  Inherited from gmfDatasourceOGC.id

  - Defined in src/datasource/DataSource.js:171

### identifierAttribute

- get identifierAttribute(): string

- #### Returns string

  Identifier attribute

  Inherited from gmfDatasourceOGC.identifierAttribute

  - Defined in src/datasource/DataSource.js:178

### legend

- get legend(): Legend

- #### Returns Legend

  legend objects

  - Defined in src/datasource/ExternalOGC.js:53

### maxResolution

- get maxResolution(): number

- #### Returns number

  Maximum resolution

  Inherited from gmfDatasourceOGC.maxResolution

  - Defined in src/datasource/DataSource.js:185

### minResolution

- get minResolution(): number

- #### Returns number

  Minimum resolution

  Inherited from gmfDatasourceOGC.minResolution

  - Defined in src/datasource/DataSource.js:192

### name

- get name(): string

- #### Returns string

  Name

  Inherited from gmfDatasourceOGC.name

  - Defined in src/datasource/DataSource.js:199

### ogcAttributesWFS

- get ogcAttributesWFS(): {}

- Returns the ogc attributes of only the WFS layers of this data source that are queryable.

  #### Returns {}

  Inherited from gmfDatasourceOGC.ogcAttributesWFS

  - Defined in src/datasource/OGC.js:923

### ogcAttributesWMS

- get ogcAttributesWMS(): {}

- Returns the ogc attributes of only the WMS layers of this data source that are queryable.

  #### Returns {}

  Inherited from gmfDatasourceOGC.ogcAttributesWMS

  - Defined in src/datasource/OGC.js:942

### ogcImageType

- get ogcImageType(): string

- #### Returns string

  OGC image type

  Inherited from gmfDatasourceOGC.ogcImageType

  - Defined in src/datasource/OGC.js:710

### ogcServerType

- get ogcServerType(): string

- #### Returns string

  OGC server type

  Inherited from gmfDatasourceOGC.ogcServerType

  - Defined in src/datasource/OGC.js:731

### ogcType

- get ogcType(): string

- #### Returns string

  OGC type

  Inherited from gmfDatasourceOGC.ogcType

  - Defined in src/datasource/OGC.js:738

### queryIconPosition

- get queryIconPosition(): number[]

- #### Returns number[]

  The queryIconPosition

  Inherited from gmfDatasourceOGC.queryIconPosition

  - Defined in src/datasource/OGC.js:745

### queryable

- get queryable(): boolean

- Whether the data source is queryable or not. For an OGC data source to be queryable, it requires the support of WFS or WMS and at least one ogc layer to be querable.

  #### Returns boolean

  Inherited from gmfDatasourceOGC.queryable

  - Defined in src/datasource/OGC.js:962

### snappable

- get snappable(): boolean

- #### Returns boolean

  Snappable

  Inherited from gmfDatasourceOGC.snappable

  - Defined in src/datasource/OGC.js:752

### snappingToEdges

- get snappingToEdges(): boolean

- #### Returns boolean

  Snapping to edges

  Inherited from gmfDatasourceOGC.snappingToEdges

  - Defined in src/datasource/OGC.js:759

### snappingToVertice

- get snappingToVertice(): boolean

- #### Returns boolean

  Snapping to vertices

  Inherited from gmfDatasourceOGC.snappingToVertice

  - Defined in src/datasource/OGC.js:766

### snappingTolerance

- get snappingTolerance(): number

- #### Returns number

  Snapping tolerance

  Inherited from gmfDatasourceOGC.snappingTolerance

  - Defined in src/datasource/OGC.js:773

### supportsAttributes

- get supportsAttributes(): boolean

- To be able to do advanced operations on a data source, such as editing or filtering, a data source must be bound to 1 set of attributes. These attributes are the ones defined by an ogcLayer. This means that to be considered to support having attributes defined, you either need to define them directly when creating the data source, or if you let the querent service get them for you using a WFS DescribeFeatureType request, the data source must have only 1 ogcLayer set, which must be queryable.

  #### Returns boolean

  Supports attributes.

  Inherited from gmfDatasourceOGC.supportsAttributes

  - Defined in src/datasource/OGC.js:997

### supportsDynamicInRange

- get supportsDynamicInRange(): boolean

- #### Returns boolean

  Whether the data source supports a dynamic `inRange` property or not, i.e. whether it can be calculated.

  Inherited from gmfDatasourceOGC.supportsDynamicInRange

  - Defined in src/datasource/DataSource.js:220

### supportsWFS

- get supportsWFS(): boolean

- #### Returns boolean

  Whether the data source supports making WFS requests or not.

  Inherited from gmfDatasourceOGC.supportsWFS

  - Defined in src/datasource/OGC.js:981

### supportsWMS

- get supportsWMS(): boolean

- #### Returns boolean

  Whether the data source supports making WMS requests or not.

  Inherited from gmfDatasourceOGC.supportsWMS

  - Defined in src/datasource/OGC.js:1010

### supportsWMTS

- get supportsWMTS(): boolean

- #### Returns boolean

  Whether the data source supports making WTMS requests or not.

  Inherited from gmfDatasourceOGC.supportsWMTS

  - Defined in src/datasource/OGC.js:1017

### timeAttributeName

- get timeAttributeName(): string

- #### Returns string

  Time attribute name

  Inherited from gmfDatasourceOGC.timeAttributeName

  - Defined in src/datasource/OGC.js:780

### timeProperty

- get timeProperty(): TimeProperty

- #### Returns TimeProperty

  Time property

  Inherited from gmfDatasourceOGC.timeProperty

  - Defined in src/datasource/OGC.js:787

### timeRangeValue

- get timeRangeValue(): TimeRange

- #### Returns TimeRange

  Time range value

  Inherited from gmfDatasourceOGC.timeRangeValue

  - Defined in src/datasource/OGC.js:635
- set timeRangeValue(range): void

- #### Parameters

  - range: TimeRange

    Time range value

  #### Returns void

  Inherited from gmfDatasourceOGC.timeRangeValue

  - Defined in src/datasource/OGC.js:654

### wfsFeatureNS

- get wfsFeatureNS(): string

- #### Returns string

  WFS feature namespace

  Inherited from gmfDatasourceOGC.wfsFeatureNS

  - Defined in src/datasource/OGC.js:794

### wfsFeaturePrefix

- get wfsFeaturePrefix(): string

- #### Returns string

  WFS feature prefix

  Inherited from gmfDatasourceOGC.wfsFeaturePrefix

  - Defined in src/datasource/OGC.js:801

### wfsFormat

- get wfsFormat(): WFS

- #### Returns WFS

  WFS format.

  Inherited from gmfDatasourceOGC.wfsFormat

  - Defined in src/datasource/OGC.js:1024

### wfsLayers

- get wfsLayers(): WFSLayer[]

- #### Returns WFSLayer[]

  WFS layers

  Inherited from gmfDatasourceOGC.wfsLayers

  - Defined in src/datasource/OGC.js:724

### wfsOutputFormat

- get wfsOutputFormat(): string

- #### Returns string

  WFS output format

  Inherited from gmfDatasourceOGC.wfsOutputFormat

  - Defined in src/datasource/OGC.js:808

### wfsUrl

- get wfsUrl(): string

- #### Returns string

  WFS url

  Inherited from gmfDatasourceOGC.wfsUrl

  - Defined in src/datasource/OGC.js:815

### wmsFormat

- get wmsFormat(): default | WMSGetFeatureInfo

- #### Returns default | WMSGetFeatureInfo

  WMS format.

  Inherited from gmfDatasourceOGC.wmsFormat

  - Defined in src/datasource/OGC.js:1031

### wmsInfoFormat

- get wmsInfoFormat(): string

- #### Returns string

  WMS info format

  Inherited from gmfDatasourceOGC.wmsInfoFormat

  - Defined in src/datasource/OGC.js:822

### wmsIsSingleTile

- get wmsIsSingleTile(): boolean

- #### Returns boolean

  WMS is single tile

  Inherited from gmfDatasourceOGC.wmsIsSingleTile

  - Defined in src/datasource/OGC.js:829

### wmsLayers

- get wmsLayers(): WMSLayer[]

- #### Returns WMSLayer[]

  WMS layers

  Inherited from gmfDatasourceOGC.wmsLayers

  - Defined in src/datasource/OGC.js:717

### wmsUrl

- get wmsUrl(): string

- #### Returns string

  WMS url

  Inherited from gmfDatasourceOGC.wmsUrl

  - Defined in src/datasource/OGC.js:836

### wmtsLayer

- get wmtsLayer(): string

- #### Returns string

  WMTS layer

  Inherited from gmfDatasourceOGC.wmtsLayer

  - Defined in src/datasource/OGC.js:843

### wmtsUrl

- get wmtsUrl(): string

- #### Returns string

  WMTS url

  Inherited from gmfDatasourceOGC.wmtsUrl

  - Defined in src/datasource/OGC.js:850

##
Methods

### combinableWithDataSourceForWFS

- combinableWithDataSourceForWFS(dataSource): boolean

- #### Parameters

  - dataSource: OGC

    Data source.

  #### Returns boolean

  Whether this data source can be combined to the given other data source to fetch features in a single WFS request.

  Inherited from gmfDatasourceOGC.combinableWithDataSourceForWFS

  - Defined in src/datasource/OGC.js:1044

### combinableWithDataSourceForWMS

- combinableWithDataSourceForWMS(dataSource): boolean

- #### Parameters

  - dataSource: OGC

    Data source.

  #### Returns boolean

  Whether this data source can be combined to the given other data source to fetch features in a single WMS request.

  Inherited from gmfDatasourceOGC.combinableWithDataSourceForWMS

  - Defined in src/datasource/OGC.js:1063

### geometryName

- geometryName(layer?): string

- #### Parameters

  - `Optional` layer: string

    The layer name.

  #### Returns string

  Geometry name

  Inherited from gmfDatasourceOGC.geometryName

  - Defined in src/datasource/OGC.js:687

### getAttributes

- getAttributes(): Attribute[]

- #### Returns Attribute[]

  Attributes

  Inherited from gmfDatasourceOGC.getAttributes

  - Defined in src/datasource/DataSource.js:157

### getCommonOGCAttributes_

- getCommonOGCAttributes_(layerNames): {}

- Collect the ogc attributes that are shared among the given layers, i.e. only the attributes that are in all the given layers are returned.

  Among the attributes, geometry columns are returned as well. Therefore, if there are no attributes with a geometry name returned, then the Filter tool have the possibilily to filter the data source using spatial filters.

  #### Parameters

  - layerNames: string[]

    List of layer names

  #### Returns {}

  Inherited from gmfDatasourceOGC.getCommonOGCAttributes_

  - Defined in src/datasource/OGC.js:1299

### getFiltrableWFSLayerName

- getFiltrableWFSLayerName(): string

- Returns the filtrable WFS layer name.

  Although a data source may contain multiple WFS wfs layers, only the first one is returned. We don't need to return more than one, since in that case a group is used in the WMS GetMap query, and each queryable layers will end up being used in WFS GetData queries sent.

  #### Returns string

  WFS layer name.

  Inherited from gmfDatasourceOGC.getFiltrableWFSLayerName

  - Defined in src/datasource/OGC.js:1170

### getInRangeWFSLayerNames

- getInRangeWFSLayerNames(res, queryableOnly?): string[]

- Returns a list of WFS layer names that are in range of a given resolution. If there's no WFS layers defined, an empty array is returned.

  #### Parameters

  - res: number

    Resolution.

  - queryableOnly: boolean = false

    Whether to additionally check if the WFS layer is queryable as well or not. Defaults to `false`.

  #### Returns string[]

  The WFS layer names that are in range.

  Inherited from gmfDatasourceOGC.getInRangeWFSLayerNames

  - Defined in src/datasource/OGC.js:1118

### getWFSLayerNames

- getWFSLayerNames(queryableOnly?): string[]

- Returns the list of WFS layer names.

  #### Parameters

  - queryableOnly: boolean = false

    Whether to additionally check if the WFS layer is queryable as well or not. Defaults to `false`.

  #### Returns string[]

  The WFS layer names.

  Inherited from gmfDatasourceOGC.getWFSLayerNames

  - Defined in src/datasource/OGC.js:1145

### getWMSLayerNames

- getWMSLayerNames(queryableOnly?): string[]

- Returns the list of WMS layer names.

  #### Parameters

  - queryableOnly: boolean = false

    Whether to additionally check if the WMS layer is queryable as well or not. Defaults to `false`.

  #### Returns string[]

  The WMS layer names.

  Inherited from gmfDatasourceOGC.getWMSLayerNames

  - Defined in src/datasource/OGC.js:1095

### haveTheSameActiveDimensions

- haveTheSameActiveDimensions(dataSource): boolean

- #### Parameters

  - dataSource: OGC

    Remote data source to compare with this one.

  #### Returns boolean

  Whether the two data sources have the same active dimensions. If both have no dimensions, they are considered to be sharing the same dimensions.

  Inherited from gmfDatasourceOGC.haveTheSameActiveDimensions

  - Defined in src/datasource/OGC.js:1203

### haveTheSameActiveDimensionsFilters

- haveTheSameActiveDimensionsFilters(dataSource): boolean

- Compare active dimensions filters of two data sources. As OpenLayers WFS format does not allow constructing multiple typenames GetFeature request with different filters we need to combine data sources depending on active dimensions filters.

  #### Parameters

  - dataSource: OGC

    Remote data source to compare with this one.

  #### Returns boolean

  Whether the two data sources have the same active dimensions filters. If both have no dimensions, they are considered to be sharing the same dimensions filters.

  #### Export

  Inherited from gmfDatasourceOGC.haveTheSameActiveDimensionsFilters

  - Defined in src/datasource/OGC.js:1241

### isAnyOGCLayerInRange

- isAnyOGCLayerInRange(res, queryableOnly?): boolean

- Check if there's at least one OGC layer in range of a given resolution.

  #### Parameters

  - res: number

    Resolution.

  - queryableOnly: boolean = false

    Whether to additionally check if the OGC layer is queryable as well or not. Defaults to `false`.

  #### Returns boolean

  At least one OGC layer is in range.

  Inherited from gmfDatasourceOGC.isAnyOGCLayerInRange

  - Defined in src/datasource/OGC.js:1084

### setAttributes

- setAttributes(attributes): void

- #### Parameters

  - attributes: Attribute[]

    Attributes

  #### Returns void

  Inherited from gmfDatasourceOGC.setAttributes

  - Defined in src/datasource/OGC.js:671